//////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2003-2008, Michael Tippach
//
// Use of this work is subject to the ASIO4ALL Private API SDK license
// agreement.
//
//                            !!! PRELIMINARY !!!
//
//////////////////////////////////////////////////////////////////////////////
//
// ASIO4ALL OEM SDK Sample.cpp : Sample code that demonstrates use of the ASIO4ALL
// private API to fill a GUI device tree with device enumeration data and allow user
// control of the enable/disable status of individual enumerated items.
//

#include "stdafx.h"
#include "ASIO4ALL OEM SDK Sample.h"
#include "a4aInterface.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

a4aInterface* TheA4aInterface = NULL;

// Forward declarations of functions included in this code module:

ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	AudioSettings(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	// TODO: Place code here.
	InitCommonControls();						// Will use newer common controls
	CoInitialize(0);							// Will use COM

	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_ASIO4ALLOEMSDKSAMPLE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance(hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_ASIO4ALLOEMSDKSAMPLE));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int)msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc = WndProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hInstance;
	wcex.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ASIO4ALLOEMSDKSAMPLE));
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wcex.lpszMenuName = MAKEINTRESOURCE(IDC_ASIO4ALLOEMSDKSAMPLE);
	wcex.lpszClassName = szWindowClass;
	wcex.hIconSm = LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;

	hInst = hInstance; // Store instance handle in our global variable

	hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_FILE_AUDIOSETUP:
			if (NULL == TheA4aInterface) TheA4aInterface = new (a4aInterface);
			DialogBox(hInst, MAKEINTRESOURCE(IDD_AUDIOSETTINGS), hWnd, AudioSettings);
			delete (TheA4aInterface);
			TheA4aInterface = NULL;
			break;
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
//
// A4A specific local declarations
//
typedef struct CBDATA {
	HWND hDlg;
	UINT reserved;
} *LPCBDATA;

BOOL EnumCallback(LPCBDATA pCbData);
void UpdateTreeStatus(HWND hDlg, BOOL bSet);

//
// Message handler for audio settings dialog
//
INT_PTR CALLBACK AudioSettings(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		//
		// Display A4A interface version.
		//
		DWORD ifcver;
		char version[9];
		CBDATA cbData;

		if (ifcver = TheA4aInterface->GetVersion())
		{
			for (int i = 0; i < 8; i++)
			{
				version[7 - i] = (char)((ifcver & 0xF) + 0x30);
				ifcver = ifcver >> 4;
			}
			version[8] = (char)0;
			SendDlgItemMessage(hDlg, IDC_STATIC_VERSION, WM_SETTEXT, 0, (LPARAM)&version[0]);
			//
			// Install an enumeration callback
			//
			cbData.hDlg = hDlg;
			TheA4aInterface->SetCallback((BOOL(*) (void*)) EnumCallback, (void*)&cbData);
			//
			// Start enumeration
			//
			TheA4aInterface->Enumerate();
		}

		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDCANCEL)
		{
			TheA4aInterface->SetCallback(NULL, 0); // Release callback
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}

		if (LOWORD(wParam) == IDOK)
		{
			UpdateTreeStatus(hDlg, TRUE);
			TheA4aInterface->SetCallback(NULL, 0); // Release callback
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}

		if (LOWORD(wParam) == IDREVERT)
		{
			UpdateTreeStatus(hDlg, FALSE);
			return (INT_PTR)TRUE;
		}

		if (LOWORD(wParam) == IDAPPLY)
		{
			UpdateTreeStatus(hDlg, TRUE);
			return (INT_PTR)TRUE;
		}

		break;
	}
	return (INT_PTR)FALSE;
}

//
//  FUNCTION: EnumCallback(LPCBDATA)
//
//  PURPOSE:  (Re-) enumerate the device tree using the A4A private API.
//
BOOL EnumCallback(LPCBDATA pCbData)
{
	//
	// Now recurse through the audio device tree.
	//
	long DeviceIndex = -1;
	TVINSERTSTRUCT insert;
	DWORD dwProperty = 0;
	HTREEITEM curDevice;
	HTREEITEM curInterface;

	SetWindowLong(GetDlgItem(pCbData->hDlg, IDC_TREE1), GWL_STYLE, GetWindowLong(GetDlgItem(pCbData->hDlg, IDC_TREE1), GWL_STYLE) | TVS_CHECKBOXES);

	while (A4A_PRIVATE_NOERROR == TheA4aInterface->GetDeviceProperty(kA4A_Device_lpszName, ++DeviceIndex, (void*)&insert.item.pszText))
	{
		long InterfaceIndex = -1;

		insert.hInsertAfter = TVI_LAST;
		insert.hParent = NULL;
		insert.item.mask = TVIF_CHILDREN | TVIF_TEXT;
		insert.item.cChildren = 1;

		curDevice = (HTREEITEM)SendDlgItemMessage(pCbData->hDlg, IDC_TREE1, TVM_INSERTITEM, 0, (LPARAM)&insert);

		while (A4A_PRIVATE_NOERROR == TheA4aInterface->GetInterfaceProperty(kA4A_Interface_lpszName, DeviceIndex, ++InterfaceIndex, (void*)&insert.item.pszText))
		{
			long PinIndex = -1;

			insert.hInsertAfter = TVI_LAST;
			insert.hParent = curDevice;
			insert.item.mask = TVIF_CHILDREN | TVIF_TEXT;
			insert.item.cChildren = 1;

			curInterface = (HTREEITEM)SendDlgItemMessage(pCbData->hDlg, IDC_TREE1, TVM_INSERTITEM, 0, (LPARAM)&insert);

			while (A4A_PRIVATE_NOERROR == TheA4aInterface->GetPinProperty(kA4A_Pin_dwDataFlow, DeviceIndex, InterfaceIndex, ++PinIndex, (void*)&dwProperty))
			{
				char Buffer[260];
				DWORD dwMaxChannels;
				DWORD dwMaxBits;
				DWORD dwMaxSR;
				DWORD dwMinSR;

				TheA4aInterface->GetPinProperty(kA4A_Pin_dwMaxChannels, DeviceIndex, InterfaceIndex, PinIndex, (void*)&dwMaxChannels);
				TheA4aInterface->GetPinProperty(kA4A_Pin_dwMaxBits, DeviceIndex, InterfaceIndex, PinIndex, (void*)&dwMaxBits);
				TheA4aInterface->GetPinProperty(kA4A_Pin_dwMinSR, DeviceIndex, InterfaceIndex, PinIndex, (void*)&dwMinSR);
				TheA4aInterface->GetPinProperty(kA4A_Pin_dwMaxSR, DeviceIndex, InterfaceIndex, PinIndex, (void*)&dwMaxSR);
				Buffer[0] = (dwProperty == 1) ? 'O' : 'I';											// KSPIN_DATAFLOW_IN = 1, KSPIN_DATAFLOW_OUT = 2, see DDK!
				wsprintf(&Buffer[1], ": %u Channels %u - %u Hz %u Bits", dwMaxChannels, dwMinSR, dwMaxSR, dwMaxBits);
				insert.item.pszText = &Buffer[0];
				insert.hInsertAfter = TVI_LAST;
				insert.hParent = curInterface;
				insert.item.mask = TVIF_CHILDREN | TVIF_TEXT;
				insert.item.cChildren = 0;
				insert.item.state = INDEXTOSTATEIMAGEMASK(1);

				SendDlgItemMessage(pCbData->hDlg, IDC_TREE1, TVM_INSERTITEM, 0, (LPARAM)&insert);
			}
		}
	}
	//
	// Update the Enabled/Disabled state of each item
	//
	UpdateTreeStatus(pCbData->hDlg, FALSE);

	return FALSE;						// Do not re-enumerate
}

//
//  FUNCTION: UpdateTreeStatus(HWND, BOOL)
//
//  PURPOSE:  Load or save the item enabled status for the whole tree.
//
void UpdateTreeStatus(HWND hDlg, BOOL bSet)
{
	TVITEM item;
	DWORD dwFlags = 0;
	long DeviceIndex = 0;
	long InterfaceIndex;
	long PinIndex;
	HTREEITEM curPin;
	HTREEITEM curIfc;
	HTREEITEM curDev = (HTREEITEM)SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETNEXTITEM, TVGN_ROOT, 0);

	item.mask = TVIF_STATE;
	item.stateMask = INDEXTOSTATEIMAGEMASK(3);

	while (curDev)
	{
		TheA4aInterface->GetDeviceProperty(kA4A_Device_dwFlags, DeviceIndex, (void*)&dwFlags);

		item.hItem = curDev;

		if (bSet)
		{
			SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETITEM, 0, (LPARAM)&item);
			dwFlags &= (A4A_FLAG_ENABLED ^ 0xFFFFFFFF);
			dwFlags |= ((item.state & INDEXTOSTATEIMAGEMASK(2)) ? A4A_FLAG_ENABLED : 0);
			TheA4aInterface->SetDeviceProperty(kA4A_Device_dwFlags, DeviceIndex, (void*)&dwFlags);
		}
		else
		{
			item.state = INDEXTOSTATEIMAGEMASK(((dwFlags & A4A_FLAG_ENABLED) ? 2 : 1));
			SendDlgItemMessage(hDlg, IDC_TREE1, TVM_SETITEM, 0, (LPARAM)&item);
		}

		curIfc = (HTREEITEM)SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETNEXTITEM, TVGN_CHILD, (LPARAM)curDev);
		InterfaceIndex = 0;

		while (curIfc)
		{
			TheA4aInterface->GetInterfaceProperty(kA4A_Interface_dwFlags, DeviceIndex, InterfaceIndex, (void*)&dwFlags);

			item.hItem = curIfc;

			if (bSet)
			{
				SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETITEM, 0, (LPARAM)&item);
				dwFlags &= (A4A_FLAG_ENABLED ^ 0xFFFFFFFF);
				dwFlags |= ((item.state & INDEXTOSTATEIMAGEMASK(2)) ? A4A_FLAG_ENABLED : 0);
				TheA4aInterface->SetInterfaceProperty(kA4A_Interface_dwFlags, DeviceIndex, InterfaceIndex, (void*)&dwFlags);
			}
			else
			{
				item.state = INDEXTOSTATEIMAGEMASK(((dwFlags & A4A_FLAG_ENABLED) ? 2 : 1));
				SendDlgItemMessage(hDlg, IDC_TREE1, TVM_SETITEM, 0, (LPARAM)&item);
			}

			curPin = (HTREEITEM)SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETNEXTITEM, TVGN_CHILD, (LPARAM)curIfc);
			PinIndex = 0;

			while (curPin)
			{
				TheA4aInterface->GetPinProperty(kA4A_Pin_dwFlags, DeviceIndex, InterfaceIndex, PinIndex, (void*)&dwFlags);

				item.hItem = curPin;

				if (bSet)
				{
					SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETITEM, 0, (LPARAM)&item);
					dwFlags &= (A4A_FLAG_ENABLED ^ 0xFFFFFFFF);
					dwFlags |= ((item.state & INDEXTOSTATEIMAGEMASK(2)) ? A4A_FLAG_ENABLED : 0);
					TheA4aInterface->SetPinProperty(kA4A_Pin_dwFlags, DeviceIndex, InterfaceIndex, PinIndex, (void*)&dwFlags);
				}
				else
				{
					item.state = INDEXTOSTATEIMAGEMASK(((dwFlags & A4A_FLAG_ENABLED) ? 2 : 1));
					SendDlgItemMessage(hDlg, IDC_TREE1, TVM_SETITEM, 0, (LPARAM)&item);
				}

				curPin = (HTREEITEM)SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETNEXTITEM, TVGN_NEXT, (LPARAM)curPin);
				PinIndex++;
			}

			curIfc = (HTREEITEM)(HTREEITEM)SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETNEXTITEM, TVGN_NEXT, (LPARAM)curIfc);
			InterfaceIndex++;
		}

		curDev = (HTREEITEM)SendDlgItemMessage(hDlg, IDC_TREE1, TVM_GETNEXTITEM, TVGN_NEXT, (LPARAM)curDev);
		DeviceIndex++;
	}
}